본문으로 건너뛰기

Data Binding & State Management in Vue Gantt

This guide helps you choose where your app owns Gantt data and how to keep chart edits synchronized. Pick one ownership model per page and keep it consistent.

Vue Gantt supports two common models:

  1. Vue state/store as source of truth (best default for most apps)
  2. Gantt as source of truth (performance-focused for chart-heavy pages)

Mental Model

The wrapper syncs props into a live Gantt instance. If users edit data in the chart, you decide whether:

  • the wrapper callback updates Vue state (Vue-owned model), or
  • the chart/backend handles changes directly (Gantt-owned model)

The main pitfall is mixed ownership. If Vue and the Gantt instance both act like the source of truth, stale data overwrites are likely.

Vue State Or Store As Source Of Truth

In this model:

  • Vue state (or Pinia) owns tasks and links
  • the wrapper receives arrays through props
  • chart edits are captured via data.save or data.batchSave
  • callback handlers update state
  • updated state flows back into the wrapper

Type recommendation for this model: use SerializedTask[] and SerializedLink[] for reactive state arrays.

Best For

  • pages with surrounding Vue UI that must reflect chart state
  • apps that already use Pinia or a centralized state layer
  • teams that want predictable unidirectional data flow

Tradeoffs

  • more application-state updates for heavy operations
  • more sync work when many edits happen in one chart action

Avoid These Patterns

  • mutating task/link data through instance while continuing to pass stale arrays from Vue state
  • ignoring wrapper callbacks and expecting chart edits to persist in Vue state automatically

Example: Store/Vue-Owned Flow

<script setup lang="ts">
import { ref } from "vue";
import VueGantt, {
type SerializedLink,
type SerializedTask,
type VueGanttDataConfig
} from "@dhtmlx/trial-vue-gantt";

const tasks = ref<SerializedTask[]>([]);
const links = ref<SerializedLink[]>([]);

const data: VueGanttDataConfig = {
save: (entity, action, item, id) => {
if (entity === "task") {
if (action === "create") tasks.value = [...tasks.value, item as SerializedTask];
if (action === "update") tasks.value = tasks.value.map(t => String(t.id) === String(id) ? item as SerializedTask : t);
if (action === "delete") tasks.value = tasks.value.filter(t => String(t.id) !== String(id));
}

if (entity === "link") {
if (action === "create") links.value = [...links.value, item as SerializedLink];
if (action === "update") links.value = links.value.map(l => String(l.id) === String(id) ? item as SerializedLink : l);
if (action === "delete") links.value = links.value.filter(l => String(l.id) !== String(id));
}
}
};
</script>

<template>
<VueGantt :tasks="tasks" :links="links" :data="data" />
</template>

For multi-change operations, move to data.batchSave and apply changes in grouped batches.

Gantt As Source Of Truth

In this model, the chart and backend own most data lifecycle operations. Vue does less live mirroring.

Best For

  • very large datasets
  • heavy auto-scheduling or bulk update flows
  • chart-focused pages where external UI does not need every live change immediately

Tradeoffs

  • less visibility of live chart state in Vue state/store
  • more discipline required if you occasionally push prop snapshots back into the wrapper

Avoid These Patterns

  • partial Vue mirroring without a reconciliation strategy
  • refeeding stale server snapshots after users edit the chart

Example: Gantt-Owned Transport

<script setup lang="ts">
import VueGantt from "@dhtmlx/trial-vue-gantt";

const data = {
load: "/api/gantt/load",
save: async (entity: string, action: string, payload: any, id: string | number) => {
const response = await fetch(`/api/gantt/${entity}`, {
method: action === "delete" ? "DELETE" : "POST",
headers: { "Content-Type": "application/json" },
body: JSON.stringify({ action, payload, id })
});

// Create handlers should return the persistent ID when backend remaps it.
return await response.json();
}
};
</script>

<template>
<VueGantt :data="data" />
</template>

Callback Contracts

This section covers the wrapper callback shapes you use in both ownership models.

data.save

save is passed to gantt.createDataProcessor(save) and receives one change at a time.

Typical function shape:

(entity: string, action: string, data: any, id: string | number) => any

Use this when changes are mostly singular and easy to process one by one.

data.batchSave

batchSave receives grouped changes:

interface BatchChanges {
tasks?: DataCallbackChange[];
links?: DataCallbackChange[];
resources?: DataCallbackChange[];
resourceAssignments?: DataCallbackChange[];
}

Entity-to-bucket mapping:

  • task / tasks -> tasks
  • link / links -> links
  • resource / resources -> resources
  • assignment / resourceAssignment / resourceAssignments -> resourceAssignments

Queue behavior summary:

  • near-term flush batching
  • create + update can be coalesced into one create with the latest payload
  • create + delete can be removed from the batch
  • internal !nativeeditor_status is stripped from payloads

Use this when one user action can produce many updates (for example auto-scheduling).

ID Remapping And Backend Responsibility

Create actions often start with temporary client-side IDs.

  • In save mode, backend responses should return persistent IDs so Gantt can remap records.
  • In batchSave mode, there is no per-item return path. If the server assigns IDs, handle remapping explicitly in your persistence workflow.

Backend responsibilities stay the same in both modes:

  • validate incoming payloads
  • enforce permissions
  • persist authoritative IDs
  • return data structures your selected transport mode expects
Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.

Data Binding & State Management in React Gantt
React Gantt supports two data binding patterns:
- React state as the source of truth - recommended for most React apps.
- Gantt as the source of truth - useful for specialized cases.
Both approaches are valid, but you should pick one and follow it consistently to avoid unexpected behavior.
This article explains both modes and shows basic examples of each.
If you haven't rendered a basic chart yet, start from the Quick Start.
Data Models
React state as the source of truth (recommended)
In this model:
- you keep
tasks,links,resources,resourceAssignmentsin React state or a state library - you pass them to
<Gantt>as props - when a user changes something, ReactGantt calls your
data.saveordata.batchSavecallback - you update React state -> React re-renders -> ReactGantt re-reads the new props.
This is the right choice in case your page has other React UI that must see the same data as Gantt and when your application has additional React components or uses a state manager that relies on the same data.
However, it will require more frequent re-parsing or re-rendering of the Gantt.
Gantt as the source of truth
In this approach, you treat ReactGantt and your backend as the main owner of the data:
- ReactGantt loads the initial dataset via
data.load, or via props, or via an imperative API call - ReactGantt applies user changes internally and/or sends them to the server
- you do not keep a mirrored copy of all tasks/links in React state that is constantly fed back into props.
The key difference is the absence of a full loop - user changes do not update the React state and React does not re-apply updated props after each change.
This model is useful when datasets are very large as it reduces the overhead of constantly updating React state when Gantt data changes and simplifies large-batch operations (like auto-scheduling) without repeated re-renders.
On the other hand, you lose the direct synchronization between Gantt data and your React state. And if you do store tasks/links in a React state, you need to be sure not to unintentionally overwrite Gantt's internal state.
React state as the source of truth
In this pattern, you hold all core collections in state and pass them as props (tasks, links, resources, resourceAssignments). Whenever the user modifies tasks or links inside the Gantt (for example, by creating or deleting a task), the Gantt triggers a callback. In this callback, you update your React state with the new or removed data. Once the state is updated, React re-renders the ReactGantt component, which in turn reads the updated props from the latest state.
Minimal example with React state
import { useState } from 'react';
import Gantt, {
Task,
Link
} from "@dhtmlx/trial-react-gantt";
import "@dhtmlx/trial-react-gantt/dist/react-gantt.css";
import { demoData } from "./demoData";
export default function ReactStateGantt() {
const [tasks, setTasks] = useState<Task[]>(demoData.tasks);
const [links, setLinks] = useState<Link[]>(demoData.links);
return (
<div style={{ height: "100vh" }}>
<Gantt
tasks={tasks}
links={links}
data={{
save: (entity, action, item, id) => {
// Update React state here (see below for patterns)
console.log("Change:", { entity, action, id, item });
},
}}
/>
</div>
);
}
This gives you a basic starting point - React controls what is rendered via props, Gantt reports changes via save callback and makes React the authoritative owner of the data.
The next sections show the typical patterns you implement inside that callback.
Handling changes with data.save
When you provide data.save, ReactGantt calls it for every change the user makes:
(entity: string, action: string, item: any, id: string|number) => {...}
Where:
entityis"task" | "link" | "resource" | "resourceAssignment"actionis"create" | "update" | "delete"itemis the created/updated/deleted objectidis the object id
Here is a simple example that updates React state directly:
function handleSave(entity, action, item, id) {
if (entity === "task") {
setTasks((prev) => {
if (action === "create") return [...prev, item];
if (action === "update") return prev.map((t) => (t.id === id ? item : t));
if (action === "delete") return prev.filter((t) => t.id !== id);
return prev;
});
}
if (entity === "link") {
setLinks((prev) => {
if (action === "create") return [...prev, item];
if (action === "update") return prev.map((l) => (l.id === id ? item : l));
if (action === "delete") return prev.filter((l) => l.id !== id);
return prev;
});
}
// You can apply the same idea for resources / assignments if needed
}
In a real application you almost never keep this logic inline:
- in Redux Toolkit this becomes a reducer or thunk
- in Zustand/Jotai/MobX/Valtio it lives in the store
- for server integration you can also call your API from here.
The state-management tutorials are built on this pattern, this example just demonstrates the starting point.
Bulk updates with data.batchSave
data.save is the most convenient entry point for capturing user changes, but it has one drawback - Auto Scheduling, as drag-shifting many tasks or other heavy operations on large projects can generate hundreds or even thousands of changes.
If you anticipate this is going to be the case for your application, you can switch to batch mode by providing data.batchSave instead of data.save. In this mode, ReactGantt will provide you with grouped changes:
type GanttBatchChanges = {
tasks?: Array<DataCallbackChange<Task>>;
links?: Array<DataCallbackChange<Link>>;
resources?: Array<DataCallbackChange<Resource>>;
resourceAssignments?: Array<DataCallbackChange<ResourceAssignment>>;
};
interface DataCallbackChange<T> {
entity: string;
action: string;
data: T;
id: number | string;
}
Here is a minimal usage example:
<ReactGantt
// ...props with tasks/links/resources etc.
data={{
batchSave: (changes) => {
console.log("Batch changes:", changes);
if (changes.tasks) {
setTasks((prev) => applyTaskBatch(prev, changes.tasks));
}
if (changes.links) {
setLinks((prev) => applyLinkBatch(prev, changes.links));
}
// Same for resources / assignments if required
},
}}
/>
Where applyTaskBatch/applyLinkBatch are small helpers that loop over { action, data, id } and return the updated array.
As a rule of thumb,
- Use
batchSavewhen you expect a lot of changes at once, and/or you want to send all changes to the backend in a single request - Use
savewhen most edits are single tasks/links, and/or you want the simplest possible integration
Loading data into React state
In the React-driven model, Gantt receives its data through React state. Where that state comes from is entirely up to your application architecture.
There are three common ways developers populate their state:
- Local component state
- State Managers (Redux Toolkit, Zustand, MobX, Jotai, XState, Valtio)
- Loading data from an API
Local component state
This is useful for quick demos, prototypes, or small applications.
Data often comes from a local seeder file, but it can also be computed or derived.
export default function GanttTemplatesDemo() {
const [tasks, setTasks] = useState(projectData.tasks);
const [links, setLinks] = useState(projectData.links);
const [resources, setResources] = useState(projectData.resources);
const [resourceAssignments, setResourceAssignments] =
useState(projectData.resourceAssignments);
return (
<div style={{height: '100vh'}}>
<ReactGantt
tasks={tasks}
links={links}
resources={resources}
resourceAssignments={resourceAssignments}
/>
</div>
);
};
This pattern is very similar to using a state manager - the only difference is where the state lives.
State Managers (Redux Toolkit, Zustand, MobX, Jotai, XState, Valtio)
In many production apps, Gantt data lives in a global store rather than inside a component.
ReactGantt integrates naturally with these libraries. You read data from the store via selectors or store hooks and pass it to <Gantt> as props, exactly the same way you would with the local state.
Here are a few illustrations of what this typically looks like.
Redux Toolkit
const { tasks, links } = useSelector((state: RootState) => state.gantt);
Zustand
const tasks = useGanttStore((state) => state.tasks);
MobX
<Gantt tasks={store.tasks} links={store.links} />
Although each library has its own API, the integration pattern is identical - you supply tasks, links, resources, etc. as props, you handle user updates through data.save or data.batchSave, the only difference is where the state originates.
The state-manager tutorials demonstrate how to implement the same pattern in each specific library:
- Using React Gantt with Redux Toolkit
- Using React Gantt with Zustand
- Using React Gantt with MobX
- Using React Gantt with XState
- Using React Gantt with Jotai
- Using React Gantt with Valtio
Loading data from an API
In real applications, you usually load data from a backend and place it into React state (local or global).
Below is a more complete example that mirrors typical usage:
import { useEffect, useState } from "react";
import Gantt, {
Task,
Link,
Resource,
ResourceAssignment,
Calendar,
} from "@dhtmlx/trial-react-gantt";
interface GanttData {
tasks: Task[];
links: Link[];
resources: Resource[];
resourceAssignments: ResourceAssignment[];
}
export default function GanttWithApi() {
const [data, setData] = useState<GanttData | null>(null);
const [isLoading, setIsLoading] = useState(true);
useEffect(() => {
async function load() {
try {
const response = await fetch("/api/gantt-data");
const raw = await response.json();
const nextData: GanttData = {
tasks: raw.tasks,
links: raw.links,
resources: raw.resources ?? [],
resourceAssignments: raw.resourceAssignments ?? []
};
setData(nextData);
} finally {
setIsLoading(false);
}
}
load();
}, []);
if (isLoading || !data) {
return <div>Loading Gantt...</div>;
}
return (
<ReactGantt
tasks={data.tasks}
links={data.links}
resources={data.resources}
resourceAssignments={data.resourceAssignments}
data={{
save: (entity, action, item, id) => {
// Update state and sync with backend here
},
}}
/>
);
}
This approach integrates cleanly with state managers:
- load data in an effect or thunk,
- store it in Redux/Zustand/MobX/etc.,
- pass it to
<Gantt>via props, - handle updates with
save/batchSave.
Gantt as the source of truth in a React app
The second binding mode is Gantt as the source of truth where Gantt (and optionally your backend) is treated as the primary data holder.
React renders the component but does not maintain tasks/links/resources as a canonical state that must flow into props after every update.
This model removes the React state <-> Gantt loop entirely.
When this model makes sense
Use Gantt as the source of truth when
- datasets are very large (thousands of tasks)
- auto-scheduling or mass updates happen frequently
- React does not need to react to every single update in real time
- the page is primarily "Gantt-centric"
React remains responsible for layout, routing, and surrounding UI, but Gantt owns the data life cycle.
Providing initial data
Even in this model, you may still give Gantt an initial dataset. The key difference is that you do not continuously reflect changes back into React state.
You can initialize Gantt using any of the following approaches: loading data via URLs, loading data via custom functions, passing an initial snapshot via props. Check the details below.
Loading data via URLs
Gantt can load everything directly from your backend using REST endpoints:
<Gantt
data={{
load: "/api/gantt/load",
save: "/api/gantt/save",
}}
/>
data.loadis called once on initializationdata.saveis triggered whenever the user modifies tasks/links.
Loading data via custom functions
Instead of URLs, you can provide async functions:
<Gantt
data={{
load: async () => {
const res = await fetch("/api/gantt/load");
return res.json();
},
save: async (entity, action, item, id) => {
// see the example below
},
}}
/>
Passing an initial snapshot via props (one-way)
You can still provide initial data via props:
<Gantt tasks={initialTasks} links={initialLinks} />
In this case, the props are simply a starting point. After initialization, Gantt maintains its own internal store and continues from there. You do not re-feed new arrays into props after every edit, because React is not considered the canonical owner of the data in this model.
How updates work
Whenever users create, edit, or delete data, Gantt triggers the save (or batchSave) callback.
Gantt initially assigns temporary IDs to created records. The backend must replace them with the real database IDs.
This logic reflects how the DataProcessor module behaves in the JS Gantt (see Server-Side Integration in JS Docs).
When a new task, link, resource, or assignment is created, the save call must return a Promise that resolves to:
{ "id": "<database id>"}
For example:
data.save = async (entity, action, item, id) => {
if (action === "create") {
const response = await fetch(`/api/${entity}`, {
method: "POST",
body: JSON.stringify(item),
headers: { "Content-Type": "application/json" }
});
const result = await response.json();
// result should contain { id: newDatabaseId }
return { id: result.id };
}
if (action === "update") {
await fetch(`/api/${entity}/${id}`, {
method: "PUT",
body: JSON.stringify(item),
headers: { "Content-Type": "application/json" }
});
return {};
}
if (action === "delete") {
await fetch(`/api/${entity}/${id}`, { method: "DELETE" });
return {};
}
};
Returning {id: newId} allows Gantt to replace the temporary ID with the permanent one.
This ensures that subsequent update/delete operations target the correct record in your database.

본문으로 건너뛰기

Data Binding & State Management in Angular Gantt

Angular Gantt supports two data ownership models:

  1. Angular state/store as source of truth (recommended for most applications).
  2. Gantt as source of truth (performance-focused for specialized pages).

Choose one model per page/feature area and keep it consistent.

Angular State Or Store As Source Of Truth

In this model:

  • your component state or RxJS store owns tasks and links,
  • the wrapper receives arrays through inputs,
  • chart changes are captured via data.save or data.batchSave,
  • callbacks update your state/store and new arrays flow back into <dhx-gantt>.

Best for

  • Angular pages with toolbars/forms that must stay in sync with the chart,
  • team codebases already built around services and RxJS,
  • predictable state transitions and easier debugging.

Tradeoffs

  • more application-state updates for heavy chart operations,
  • more frequent synchronization work during bulk edits.

Anti-patterns to avoid

  • mutating data through instance while still pushing stale tasks/links arrays from Angular state,
  • ignoring data.save / data.batchSave and expecting chart edits to persist in your app state automatically.

Full-flow example (component state)

import { Component } from '@angular/core';
import {
DhxGanttComponent,
type AngularGanttDataConfig,
type SerializedTask,
type SerializedLink,
} from '@dhtmlx/trial-angular-gantt';

@Component({
standalone: true,
imports: [DhxGanttComponent],
template: `<dhx-gantt [tasks]="tasks" [links]="links" [data]="dataConfig"></dhx-gantt>`,
})
export class GanttPageComponent {
tasks: SerializedTask[] = [];
links: SerializedLink[] = [];

dataConfig: AngularGanttDataConfig = {
save: (entity, action, item, id) => {
if (entity === 'task') {
if (action === 'create') this.tasks = [...this.tasks, item];
if (action === 'update') this.tasks = this.tasks.map((t) => String(t.id) === String(id) ? { ...t, ...item } : t);
if (action === 'delete') this.tasks = this.tasks.filter((t) => String(t.id) !== String(id));
}

if (entity === 'link') {
if (action === 'create') this.links = [...this.links, item];
if (action === 'update') this.links = this.links.map((l) => String(l.id) === String(id) ? { ...l, ...item } : l);
if (action === 'delete') this.links = this.links.filter((l) => String(l.id) !== String(id));
}
},
};
}

Gantt As Source Of Truth

In this model, the chart and backend own most of the runtime data lifecycle.

Best for

  • very large datasets,
  • chart-centric screens,
  • heavy auto-scheduling or chained edits where frequent app-store updates are expensive.

Tradeoffs

  • less immediate visibility of live chart state in Angular services/components,
  • extra discipline required when mixing occasional input updates with imperative operations.

Anti-patterns to avoid

  • partial mirroring without a clear reconciliation plan,
  • refeeding stale server snapshots after users already changed data in the chart.

Server transport example

dataConfig = {
load: '/api/gantt/load',
save: async (entity: string, action: string, payload: any, id: string | number) => {
const response = await fetch(`/api/gantt/${entity}`, {
method: action === 'delete' ? 'DELETE' : 'POST',
headers: { 'Content-Type': 'application/json' },
body: JSON.stringify({ action, payload, id }),
});

return await response.json();
},
};

Use this when your backend is the authoritative state owner and Angular does not need to mirror every edit in real time.

Callback Contracts

data.save

save is passed to gantt.createDataProcessor(save) and receives per-change payloads.

Typical function shape:

(entity: string, action: string, data: any, id: string | number) => any

Use this when changes are mostly singular and easy to apply one-by-one.

data.batchSave

batchSave receives grouped payloads:

interface BatchChanges {
tasks?: DataCallbackChange[];
links?: DataCallbackChange[];
resources?: DataCallbackChange[];
resourceAssignments?: DataCallbackChange[];
}

Entity-to-bucket mapping includes:

  • task / tasks -> tasks
  • link / links -> links
  • resource / resources -> resources
  • assignment / resourceAssignment / resourceAssignments -> resourceAssignments

Queue behavior summary:

  • small debounce-based batching,
  • create + update coalesced into one create with the latest data,
  • create + delete removed,
  • internal !nativeeditor_status stripped from payloads.

Use this when one chart action can trigger many downstream changes.

Loading Data Into Angular State

Local component state

Use local component fields for small pages or prototypes.

Load data in Angular, then assign arrays to tasks and links inputs. Keep callback handlers in the same component.

Use an injectable service with a BehaviorSubject (or similar) to hold tasks, links, and UI state.

This is the pattern used in the Angular public sample and documented in Using Angular Gantt with RxJS.

Loading from an API into Angular state

Typical flow:

  1. Fetch data in a service or route resolver.
  2. Normalize or map date formats if needed.
  3. Push data into your store/component state.
  4. Pass the arrays to <dhx-gantt>.
  5. Handle edits with data.save or data.batchSave and persist to backend.

Use this when Angular state is your source of truth and the backend is still the long-term persistent source.

Gantt As Source Of Truth In An Angular App

When this model makes sense

Choose it when the page is mostly the chart and the surrounding Angular UI does not need to react to every task/link update.

Providing initial data

You can initialize Gantt-managed data with any of these patterns:

  • data.load URL
  • data.load function (sync or async)
  • initial tasks/links arrays, then stop treating them as live source-of-truth inputs

How updates work

The Gantt instance applies user changes internally and sends them through save or batchSave.

Angular does not need to reassign tasks/links after each change unless you explicitly want to mirror them.

ID Remapping And Backend Responsibility

Create actions often begin with temporary client-side IDs.

  • In save mode, backend responses should return persistent IDs so Gantt can remap internal records.
  • In batchSave mode, there is no per-item return path, so ID remapping must be handled explicitly in your persistence workflow if the backend assigns new IDs.

Backend remains responsible for:

  • validation,
  • permission checks,
  • persistent ID assignment,
  • consistent response payloads.

Continue With

Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.